package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowFirewallGroupDetailsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowFirewallGroupDetailsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowFirewallGroupDetailsLogic {
	return &ShowFirewallGroupDetailsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowFirewallGroupDetailsLogic) ShowFirewallGroupDetails(req *types.ShowFirewallGroupDetailsReq) (resp *types.ShowFirewallGroupDetailsResp, err error) {
	// todo: add your logic here and delete this line
	ShowFirewallGroupDetailsReq := &openstack.ShowFirewallGroupDetailsReq{}
	err = copier.CopyWithOption(ShowFirewallGroupDetailsReq, req, copier.Option{Converters: utils.Converters})
	ShowFirewallGroupDetailsResp, err := l.svcCtx.OpenstackRpc.ShowFirewallGroupDetails(l.ctx, ShowFirewallGroupDetailsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowFirewallGroupDetailsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowFirewallGroupDetailsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
